{ The entire game as a Pascal library to be used via WAsm Shim }
library CSLib;
uses
  WAsmUtil, DataLoad, Settings, Math, Engine, GfxDrv;

{ Called to initialize the game }
procedure Initialize;
begin
  // Initialize
  WAsmLog('Loading settings');
  LoadSettings;
  WAsmLog('Initializing engine');
  InitializeEngine;
  WAsmLog('Loading palette');
  GRenderer.ColorPalette.LoadJASCPalette(DataDirectoryPrefix + 'colors.pal');
  // Initialize the game
  WAsmLog('Initializing the game');
  GGame.Initialize;
  WAsmLog('Initialization complete');
end;

{ Called to run a single engine cycle }
procedure RunCycle;
begin
  RunEngineCycle;
end;

{ Called to shutdown the game }
procedure Shutdown;
begin
  ShutdownEngine;
end;

{ Called to process an input event }
procedure InputEvent(Ev, A, B: Int32);
begin
  //TAndroidInputDriver(GInput).NotifyInputEvent(Ev, A, B);
end;

{ Called to fill audio buffer }
procedure AudioCallback(Buffer: PPointer; Size: PInt32);
begin
  //TAndroidSoundDriver(GSound).Callback(Buffer, Size);
end;

exports
  Initialize,
  RunCycle,
  Shutdown,
  InputEvent,
  AudioCallback;

end.
