{ Game Over screen }
unit GOverScn;

interface

uses
  UIScrns;

type
  { TGameOverScreen - Game over screen }
  TGameOverScreen = class(TUIScreen)
  protected
    // TUIScreen methods
    procedure PerformCommand(Sender: TUIControl; ACommand: string); override;
    procedure Cancel; override;
  public
    // TScreen methods
    procedure Draw; override;
    function FullScreen: Boolean; override;
  public
    constructor Create;
  end;

implementation

uses
  GfxDrv, Engine, Fonts;

{ TGameOverScreen }
constructor TGameOverScreen.Create;
var
  W, H: Integer;
begin
  inherited Create;
  // Setup background style
  BackgroundStyle:=uisbShade;
  // Setup UI
  GRenderer.TextSize('Game Over', TBitFont(GResourceManager.DefaultFont), W, H);
  AddControl(TUILabel.Create(BaseX + 160 - W div 2, BaseY + 100 - H div 2, 'Game Over'));
  AddControl(TUITextButton.Create(BaseX + 180 - W div 2, BaseY + 150, 'Quit', 'quit'));
end;

procedure TGameOverScreen.PerformCommand(Sender: TUIControl; ACommand: string);
begin
  if ACommand='quit' then QuitEngine;
end;

procedure TGameOverScreen.Cancel;
begin
end;

procedure TGameOverScreen.Draw;
begin
  GRenderer.FillRectangle(0, 0, HRes, VRes, 0);
  inherited Draw;
end;

function TGameOverScreen.FullScreen: Boolean;
begin
  Result:=True;
end;

end.
