{ Inventory screen }
unit InvenScn;

interface

uses
  UIScrns, InputDrv;

type

  { TInventoryScreen - Inventory screen }
  TInventoryScreen = class(TUIScreen)
  private
    // List for the inventory items
    Items: TUIList;
  protected
    // TScreen methods
    procedure Entered; override;
  protected
    // TUIScreen methods
    procedure PerformCommand(Sender: TUIControl; ACommand: string); override;
    procedure Cancel; override;
  public
    // TScreen methods
    function KeyDown(Key: TInputKey): Boolean; override;
  public
    constructor Create;
  end;

implementation

uses
  GfxDrv, Engine, EPetra;

{ TInventoryScreen }
constructor TInventoryScreen.Create;
begin
  inherited Create;
  // Setup background style
  BackgroundStyle:=uisbShade;
  // Setup UI
  AddControl(TUILabel.Create(BaseX + 10, BaseY + 10, 'Inventory:'));
  Items:=TUIList.Create(BaseX + 10, BaseY + 30, 290, 120, [], '');
  AddControl(Items);
  AddControl(TUITextButton.Create(BaseX + 270, BaseY + 170, 'Quit', 'quit'));
end;

procedure TInventoryScreen.Entered;
var
  I: Integer;
begin
  inherited Entered;
  Items.Clear;
  with TPetra(GGame.Player) do begin
    for I:=0 to InventoryItemCount - 1 do
      Items.AddItem(InventoryItems[I]);
    if InventoryItemCount > 0 then
      Items.ItemIndex:=0;
  end;
end;

procedure TInventoryScreen.PerformCommand(Sender: TUIControl; ACommand: string);
begin
  if ACommand='quit' then QuitEngine;
end;

procedure TInventoryScreen.Cancel;
begin
  // Exit the inventory screen
  GScreenManager.Screen:=nil;
end;

function TInventoryScreen.KeyDown(Key: TInputKey): Boolean;
begin
  if inherited KeyDown(Key) then Exit(True);
  // Cheat(ish): F7 kills Petra
  {$IFDEF PETRAGCW}
  if ((Key=ikBackspace) and GInput.KeyState[ikShift]) or
     ((Key=ikShift) and GInput.KeyState[ikBackspace]) then begin
  {$ELSE}
  if Key=ikF7 then begin
  {$ENDIF}
    TPetra(GGame.Player).PerformCommand('die');
    Cancel;
    Exit(True);
  end;
  // Not handled
  Result:=False;
end;

end.

